window.addEventListener('load',principal,false);

// variables de entorno
var canvas = null, ctx = null;
var imageData = null;
// variables para contadores
var contador_segons=0;
var contador_minuts=0;
// variables de posiciones iniciales

// entidades

var superM_player = new superM(40,40,32,36);
var colisiones = 0;
var velocity = 2;
var estat_velocity = 0;
var direccio = 0;
var direccio_prota = 0;
var punts_vida = 500;
var punts_partida = 0;
var nivell = 0;
var op1 = -1;
var op2 = -1;

var operacio = "op";
var resultat = -1;
var mostrat = false;

var enemic = new enemic(200,200,32,36,0);


var angle_enemic = Math.PI/2;
var enemigo2 = new Image();
enemigo2.src = 'Imagenes/goma50.png';

var taula_quadrats = new Array();
var num_quadrats = 14;

// index per controlar el numero d'operacions lliures que tenim a la taula
var num_op_lliures;
var aux_op_lliures;
num_op_lliures = 0;
aux_op_lliures = 0;

// taula que guardara les operacions lliures que anirem formant
var taula_operacions_lliures =  new Array();

var taula_estrelles = new Array();
var num_estrelles = 400;

var punts_roig = 10;
var punts_groc = 10;
var punts_verd = 10;
var punts_blau = 10 ;

var velocityDOWN = new superM(200,200,40,40);
var vDOWN = new Image();
vDOWN.src = 'Imagenes/zzz.png';

var taula = new Array();

// variables eventos de raton
var coordenadaX = null;
var coordenadaY = null;

var pos_ant_x = 0;
var pos_ant_y = 0;

var angle = Math.PI/2;
var angle_direccio = Math.PI/2;

var prota = new Image();
prota.src = 'Imagenes/llapis50.png'

// definim les variables que contindran les imatges dels diferents numeros
var numero_zero = new Image();
var numero_u = new Image();
var numero_dos = new Image();
var numero_tres = new Image();
var numero_quatre = new Image();
var numero_cinc = new Image();
var numero_sis = new Image();
var numero_set = new Image();
var numero_vuit = new Image();
var numero_nou = new Image();
// definim les variables que contindran les imatges de les operacions matematiques
var suma = new Image();
var resta = new Image();
var producte = new Image();
var divisio = new Image();

numero_zero.src = 'Imagenes/zero.png';
numero_u.src = 'Imagenes/u.png';
numero_dos.src = 'Imagenes/dos.png';
numero_tres.src = 'Imagenes/tres.png';
numero_quatre.src = 'Imagenes/quatre.png';
numero_cinc.src = 'Imagenes/cinc.png';
numero_sis.src = 'Imagenes/sis.png';
numero_set.src = 'Imagenes/set.png';
numero_vuit.src = 'Imagenes/vuit.png';
numero_nou.src = 'Imagenes/nou.png';

suma.src = 'Imagenes/suma.png';
resta.src = 'Imagenes/resta.png';
producte.src = 'Imagenes/producte.png';
divisio.src = 'Imagenes/divisio.png';

var dire = new Image();
dire.src = 'Imagenes/direccio.png';

var exclamacion_rojo = new Image();
var exclamacion_amarillo = new Image();
var exclamacion_verde = new Image();
var exclamacion_azul = new Image();

exclamacion_rojo.src = 'Imagenes/exclamacion-rojo.png';
exclamacion_amarillo.src = 'Imagenes/exclamacion-amarillo.png';
exclamacion_verde.src = 'Imagenes/exclamacion-verde.png';
exclamacion_azul.src = 'Imagenes/exclamacion-azul.png';

var barra_vida = new Image();
barra_vida.src = 'Imagenes/barra-vida.png';

var fons = new Image();
fons.src = 'Imagenes/fondo.png';

function principal(){

	canvas=document.getElementById('canvas');
	canvas.style.background="rgba(10,0,10,0.9)"; 					// color de fondo
	ctx=canvas.getContext('2d');
	//imageData = ctx.getImageData(0,0,canvas.width, canvas.height);
	
	ctx.drawImage(fons, 0,0);
	
	ctx.fillStyle = "blue";
	ctx.fillRect(1010, 290, 100, 30);
	ctx.fillStyle = "orange";
	ctx.font='40px Coriew New';	
	ctx.fillText('Super M', 1000, 250);
	ctx.font='24px Coriew New';
	ctx.fillText('Inici joc', 1020, 310); // operacions lliures
	ctx.fill();
	
	
	canvas.addEventListener("click",			
	// al fer click s'activara la funcio
	function(e){
		
		if(e.clientX-canvas.offsetLeft > 1010 && e.clientX-canvas.offsetLeft < 1110){		
		
			if(e.clientY-canvas.offsetTop > 290 && e.clientY-canvas.offsetTop < 320){		
				//si fem click dins del 'start game' iniciem tota l'estructura
				for (i=0;i<num_quadrats;i++) {
					x = random(canvas.width/10-1)*10;
					y = random(canvas.height/10-1)*10;
					dir = direccio;
					if(i==0){
						tipo="zero";
						color="red";
					}
					if(i==1){
						tipo="u";
						color="yellow";
					}
					if(i==2){
						tipo="dos";
						color="green";
					}
					if(i==3){
						tipo="tres";
						color="blue";
					}
					if(i==4){
						tipo="quatre";
						color="red";
					}
					if(i==5){
						tipo="cinc";
						color="yellow";
					}
					if(i==6){
						tipo="sis";
						color="green";
					}
					if(i==7){
						tipo="set";
						color="blue";
					}
					if(i==8){
						tipo="vuit";
						color="red";
					}
					if(i==9){
						tipo="nou";
						color="yellow";
					}
					if(i==10){
						tipo="suma";
						color="green";
					}
					if(i==11){
						tipo="resta";
						color="blue";
					}
					if(i==12){
						tipo="producte";
						color="red";
					}
					if(i==13){
						tipo="divisio";
						color="blue";
					}				
					
					taula_quadrats.push(new quadrat(x,y,dir,x,y,10,10,false,color,tipo)); 
				}
				// ESTRELLA
				for (i=0;i<num_estrelles;i++) {
					x = random(canvas.width/5-1)*5;
					y = random(canvas.height/5-1)*5;
					dir = direccio;
					taula_estrelles.push(new estrella(x,y,3,3,4,dir,false));
				}	
				//********************************************
				//********************************************
				x = random(canvas.width/60-1)*60;
				y = random(canvas.height/60-1)*60;	
				enemic.x = x;
				enemic.y = y;
				enemic.estat = 0;
				//********************************************
				//********************************************
				x = random(canvas.width/40-1)*40;
				y = random(canvas.height/40-1)*40;	
				velocityDOWN.x = x;
				velocityDOWN.y = y;
	
				setInterval(actualiza,1E3/30);									
				setInterval(incrementar_temps,1000);
				setTimeout(canvi_direccio,1000*30);
			}	
		}
	}
	,false);

}

function actualiza(){

	// CODI DEL MOVIMENT DELS ELEMENTS DE COLOR ROIG,GROC,VERD,BLAU
	//--------------------------------------------------------------------------------------
	for(i=0;i<num_quadrats;i++){
		if(taula_quadrats[i].direccio == 0){   
			// direccio cap a la dreta
			taula_quadrats[i].x = taula_quadrats[i].x + velocity;
			if (taula_quadrats[i].x>canvas.width){
				taula_quadrats[i].canvi = true;
			}	
		}
		if(taula_quadrats[i].direccio == 1){   
			// direccio cap a l'esquerra
			taula_quadrats[i].x = taula_quadrats[i].x - velocity;
			if (taula_quadrats[i].x<0){
				taula_quadrats[i].canvi = true;
			}
		}
		if(taula_quadrats[i].direccio == 2){   
			// direccio cap a dalt
			taula_quadrats[i].y = taula_quadrats[i].y - velocity;
			if (taula_quadrats[i].y<0){
				taula_quadrats[i].canvi = true;
			}
		}
		if(taula_quadrats[i].direccio == 3){   
			// direccio cap a baix
			taula_quadrats[i].y = taula_quadrats[i].y + velocity;
			if (taula_quadrats[i].y>canvas.height){
				taula_quadrats[i].canvi = true;
			}	
		}
		if(taula_quadrats[i].direccio == 4){   
			// direccio cap a la dreta-amunt
			taula_quadrats[i].x = taula_quadrats[i].x + velocity;
			if (taula_quadrats[i].x>canvas.width){
				taula_quadrats[i].canvi = true;
			}	
			taula_quadrats[i].y = taula_quadrats[i].y - velocity;
			if (taula_quadrats[i].y<0){
				taula_quadrats[i].canvi = true;
			}
			if (taula_quadrats[i].x>canvas.width&&taula_quadrats[i].y<0){
				taula_quadrats[i].canvi = true;
			}
		}
		if(taula_quadrats[i].direccio == 5){   
			// direccio cap a la esquerra-avall
			taula_quadrats[i].x = taula_quadrats[i].x - velocity;
			if (taula_quadrats[i].x<0){
				taula_quadrats[i].canvi = true;
			}
			taula_quadrats[i].y = taula_quadrats[i].y + velocity;
			if (taula_quadrats[i].y>canvas.height){
				taula_quadrats[i].canvi = true;
			}	
			if (taula_quadrats[i].x<0&&taula_quadrats[i].y>canvas.height){
				taula_quadrats[i].canvi = true;
			}	
		}
		if(taula_quadrats[i].direccio == 6){   
			// direccio cap a la esquerra-amunt
			taula_quadrats[i].x = taula_quadrats[i].x - velocity;
			if (taula_quadrats[i].x<0){
				taula_quadrats[i].canvi = true;
			}
			taula_quadrats[i].y = taula_quadrats[i].y - velocity;
			if (taula_quadrats[i].y<0){
				taula_quadrats[i].canvi = true;
			}
			if (taula_quadrats[i].x<0&&taula_quadrats[i].y<0){
				taula_quadrats[i].canvi = true;
			}
		}
		if(taula_quadrats[i].direccio == 7){   
			// direccio cap a la dreta-avall
			taula_quadrats[i].x = taula_quadrats[i].x + velocity;
			if (taula_quadrats[i].x>canvas.width){
				taula_quadrats[i].canvi = true;
			}	
			taula_quadrats[i].y = taula_quadrats[i].y + velocity;
			if (taula_quadrats[i].y>canvas.height){
				taula_quadrats[i].canvi = true;
			}	
			if (taula_quadrats[i].x>canvas.width&&taula_quadrats[i].y>canvas.height){
				taula_quadrats[i].canvi = true;
			}	
		}	
		
		if (taula_quadrats[i].canvi == true){
			// primer definixo una posicio aleatoria dintre de la regio canvas
			x = random(canvas.width/10-1)*10;
			y = random(canvas.height/10-1)*10;
			taula_quadrats[i].x = x;
			taula_quadrats[i].y = y;
			taula_quadrats[i].direccio = direccio;
			taula_quadrats[i].x_ini = x;
			taula_quadrats[i].y_ini = y;		
			taula_quadrats[i].canvi = false;		
		}
		
		if (superM_player.colision(taula_quadrats[i])){
			//colisiones = colisiones + 1;
			punts_vida = punts_vida - 2;
			if(punts_vida < 0)punts_vida = 0; // game over
		}
			
		if (enemic.colision(taula_quadrats[i])){
			x = random(canvas.width/60-1)*60;
			y = random(canvas.height/60-1)*60;	
			enemic.x = x;
			enemic.y = y;
			enemic.estat = 0;
		}
	}


	for (i=0;i<num_estrelles;i++) {		
		if(taula_estrelles[i].direccio == 0){   
			// direccio cap a la dreta
			taula_estrelles[i].x = taula_estrelles[i].x + 0.4;//velocity-factor;
			if (taula_estrelles[i].x>canvas.width){
				taula_estrelles[i].canvi = true;
			}	
		}
		if(taula_estrelles[i].direccio == 1){   
			// direccio cap a l'esquerra
			taula_estrelles[i].x = taula_estrelles[i].x - 0.4;//velocity-factor;
			if (taula_estrelles[i].x<0){
				taula_estrelles[i].canvi = true;
			}
		}
		if(taula_estrelles[i].direccio == 2){   
			// direccio cap a dalt
			taula_estrelles[i].y = taula_estrelles[i].y - 0.4;//velocity-factor;
			if (taula_estrelles[i].y<0){
				taula_estrelles[i].canvi = true;
			}
		}
		if(taula_estrelles[i].direccio == 3){   
			// direccio cap a baix
			taula_estrelles[i].y = taula_estrelles[i].y + 0.4;//velocity-factor;
			if (taula_estrelles[i].y>canvas.height){
				taula_estrelles[i].canvi = true;
			}	
		}
		if(taula_estrelles[i].direccio == 4){   
			// direccio cap a la dreta-amunt
			taula_estrelles[i].x = taula_estrelles[i].x + 0.4;
			if (taula_estrelles[i].x>canvas.width){
				taula_estrelles[i].canvi = true;
			}	
			taula_estrelles[i].y = taula_estrelles[i].y - 0.4;
			if (taula_estrelles[i].y<0){
				taula_estrelles[i].canvi = true;
			}
			if (taula_estrelles[i].x>canvas.width&&taula_estrelles[i].y<0){
				taula_estrelles[i].canvi = true;
			}
		}
		if(taula_estrelles[i].direccio == 5){   
			// direccio cap a la esquerra-avall
			taula_estrelles[i].x = taula_estrelles[i].x - 0.4;
			if (taula_estrelles[i].x<0){
				taula_estrelles[i].canvi = true;
			}
			taula_estrelles[i].y = taula_estrelles[i].y + 0.4;
			if (taula_estrelles[i].y>canvas.height){
				taula_estrelles[i].canvi = true;
			}	
			if (taula_estrelles[i].x<0&&taula_estrelles[i].y>canvas.height){
				taula_estrelles[i].canvi = true;
			}	
		}
		if(taula_estrelles[i].direccio == 6){   
			// direccio cap a la esquerra-amunt
			taula_estrelles[i].x = taula_estrelles[i].x - 0.4;
			if (taula_estrelles[i].x<0){
				taula_estrelles[i].canvi = true;
			}
			taula_estrelles[i].y = taula_estrelles[i].y - 0.4;
			if (taula_estrelles[i].y<0){
				taula_estrelles[i].canvi = true;
			}
			if (taula_estrelles[i].x<0&&taula_estrelles[i].y<0){
				taula_estrelles[i].canvi = true;
			}
		}
		if(taula_estrelles[i].direccio == 7){   
			// direccio cap a la dreta-avall
			taula_estrelles[i].x = taula_estrelles[i].x + 0.4;
			if (taula_estrelles[i].x>canvas.width){
				taula_estrelles[i].canvi = true;
			}	
			taula_estrelles[i].y = taula_estrelles[i].y + 0.4;
			if (taula_estrelles[i].y>canvas.height){
				taula_estrelles[i].canvi = true;
			}	
			if (taula_estrelles[i].x>canvas.width&&taula_estrelles[i].y>canvas.height){
				taula_estrelles[i].canvi = true;
			}	
		}
		
		if (taula_estrelles[i].canvi == true){
			// primer definixo una posicio aleatoria dintre de la regio canvas
			x = random(canvas.width/5-1)*5;
			y = random(canvas.height/5-1)*5;
			dir = direccio;			
			taula_estrelles[i].x = x;
			taula_estrelles[i].y = y;
			taula_estrelles[i].direccio = dir;
			taula_estrelles[i].canvi = false;
		}		
	}
	
	
	if (superM_player.colision(velocityDOWN)){
			x = random(canvas.width/40-1)*40;
			y = random(canvas.height/40-1)*40;	
			velocityDOWN.x = x;
			velocityDOWN.y = y;
			estat_velocity = 1;			
			setTimeout(nova_velocitat,1000*10);
			
	}

	pos_ant_x = superM_player.x;
	pos_ant_y = superM_player.y;
	
	superM_player.x = coordenadaX;
	superM_player.y = coordenadaY;	
	
	// prota cap a la dreta
	if(pos_ant_x<superM_player.x){		
		angle = Math.PI/2;	
		direccio_prota = 0;
	}
	// prota cap a l'esquerra
	if(pos_ant_x>superM_player.x){		
		angle = -Math.PI/2;		
		direccio_prota = 1;
	}
	// prota cap avall
	if(pos_ant_y<superM_player.y){		
		angle = Math.PI;	
		direccio_prota = 3;
	}
	// prota cap amunt
	if(pos_ant_y>superM_player.y){		
		angle = 0;		
		direccio_prota = 2;
	}
	
	// direccio dreta i amunt
	if(pos_ant_x<superM_player.x&&pos_ant_y>superM_player.y){		
		//angle = angle - 0.2;
		//if(angle<=0)angle=0;
		angle = Math.PI/4;	
		direccio_prota = 4;
	}
	
	// direccio dreta i avall
	if(pos_ant_x<superM_player.x&&pos_ant_y<superM_player.y){
		//angle = Math.PI/2;
		//angle = angle + 0.2;
		//if(angle>=Math.PI)angle=Math.PI;
		angle = Math.PI/4+Math.PI/2;	
		direccio_prota = 7;
	}
	// direccio esquerra i amunt
	if(pos_ant_x>superM_player.x&&pos_ant_y>superM_player.y){
		//angle = -Math.PI/2;
		//angle = angle + 0.2;
		//if(angle>=Math.PI*2)angle=Math.PI*2;
		angle = Math.PI/2+Math.PI+Math.PI/4;	
		direccio_prota = 6;
	}
	// direccio esquerra i avall
	if(pos_ant_x>superM_player.x&&pos_ant_y<superM_player.y){
		//angle = -Math.PI/2;
		//angle = angle - 0.2;
		//if(angle<=Math.PI)angle=Math.PI;
		angle = Math.PI/4+Math.PI;	
		direccio_prota = 5;
	}
	
	//********************************************
	//********************************************
	aux1 = superM_player.x;
	aux2 = superM_player.y;
	
	if(enemic.estat == 1){
		// esquerra
		if (aux1<enemic.x){
			enemic.x = enemic.x - 5;
			//angle_enemic = -Math.PI/2;		
		}
		// dreta
		if (aux1>enemic.x){
			enemic.x = enemic.x + 5;
			//angle_enemic = Math.PI/2;	
		}
		// amunt
		if (aux2<enemic.y){
			enemic.y = enemic.y - 5;
			//angle_enemic = 0;		
		}
		// avall
		if (aux2>enemic.y){
			enemic.y = enemic.y + 5;
			//angle_enemic = Math.PI;	
		}
		// esquerra-amunt
		if (aux1<enemic.x&&aux2<enemic.y){
			enemic.x = enemic.x - 3;
			enemic.y = enemic.y - 3;
			angle_enemic = Math.PI/2+Math.PI+Math.PI/4;
		}
		// esquerra-avall
		if (aux1<enemic.x&&aux2>enemic.y){
			enemic.x = enemic.x - 3;
			enemic.y = enemic.y + 3;
			angle_enemic = Math.PI/4+Math.PI;	
		}
		// dreta-amunt
		if (aux1>enemic.x&&aux2<enemic.y){
			enemic.x = enemic.x + 3;
			enemic.y = enemic.y - 3;
			angle_enemic = Math.PI/4;	
		}
		// dreta-avall
		if (aux1>enemic.x&&aux2>enemic.y){
			enemic.x = enemic.x + 3;
			enemic.y = enemic.y + 3;
			angle_enemic = Math.PI/4+Math.PI/2;	
		}
		// ens ha atrapat ALTRES COLISIONS!!!!

		if (superM_player.colision(enemic)){
			x = random(canvas.width/60-1)*60;
			y = random(canvas.height/60-1)*60;	
			enemic.x = x;
			enemic.y = y;
			enemic.estat = 0;
			punts_partida = punts_partida - 1;
			if(punts_partida < 0)punts_partida = 0; // game over
			
		}
	}
	aux = new enemic_auxiliar(enemic.x-44, enemic.y-42, 120, 120);
	if (superM_player.colision(aux)){
		enemic.estat = 1;
	}
	
	taula.push(new Point(superM_player.x,superM_player.y));
		
	dibujar(ctx);

}

function dibujar(ctx){
	
	ctx.clearRect(0,0,canvas.width,canvas.height);					// limpia TODA la pantalla !!!	
	
	ctx.beginPath();
	ctx.fillStyle="violet";
	ctx.strokeStyle="black";
	
	ctx.drawImage(prota,superM_player.x,superM_player.y-50);
	
	ctx.fill();
	ctx.stroke();
	
	ctx.beginPath();
	ctx.fillStyle="rgba(255,255,100,0.3)";
	ctx.arc(enemic.x+16,enemic.y+18,60,0,Math.PI*2,true);
	ctx.fill();
	ctx.closePath();
	
	ctx.drawImage(enemigo2,enemic.x,enemic.y);	
		
	ctx.save();
	ctx.translate(627+20,2+20);
	ctx.rotate(angle_direccio);//*Math.PI/180);
	ctx.drawImage(dire,-20,-20);
	ctx.restore();
			
	ctx.beginPath();
	ctx.strokeStyle="white";
	ctx.lineWidth=3;
	
	for(d=0;d<taula.length;d++){
		p=taula[d];
		p2=taula[d+1];
			
		if(d==0){
			ctx.moveTo(p.position.x,p.position.y);
		}
		else {
			//p2&&ctx.quadraticCurveTo(p.position.x,p.position.y,p.position.x+(p2.position.x-p.position.x)/2,p.position.y+(p2.position.y-p.position.y)/2);
			p2&&ctx.lineTo(p2.position.x,p2.position.y);
		
		}	
		
	}	
	
	xmin = 9999;
	ymin = 9999;
	
	xmax = 0;
	ymax = 0;
	
		for(d=0;d<taula.length;d++){
		
			p=taula[d];
					
			if (xmin > p.position.x){
				xmin = p.position.x;
			}			
			if (ymin > p.position.y){
				ymin = p.position.y;
			}
			if (xmax < p.position.x){
				xmax = p.position.x;
			}			
			if (ymax < p.position.y){
				ymax = p.position.y;
			}
			
		}	
	

	ctx.stroke();
	ctx.closePath();	
	
	taula.length>24&&taula.shift(); // es com un if
	
	interseccio_valida = false;		
		
	w1 = taula[taula.length-2];
	q1 = taula[taula.length-1];	
	
	for(i=0;i<taula.length-2;i++){
		
		// busco si hi ha interseccio en alguna recta colocada en anterioritat a la recta que estic comprovan	
			w2 = taula[i];
			q2 = taula[i+1];			
			
			pi = controlar_interseccio(w1.position.x,w1.position.y,q1.position.x,q1.position.y,w2.position.x,w2.position.y,q2.position.x,q2.position.y);//,xmin,ymin,xmax,ymax);
			if (pi.position.x==-1&&pi.position.y==-1){
				interseccio_valida = false;//ctx.fill();
			}
			else{
				//if (pi.position.x>xmin&&pi.position.y>ymin&&pi.position.x<xmax-xmin&&pi.position.y<ymax-ymin){
					condicio1=false;
					condicio2=false;
					condicio3=false;
					condicio4=false;
					// controlo els limits de la RECTA1
					if(q1.position.x>w1.position.x){
						if(pi.position.x>w1.position.x&&pi.position.x<q1.position.x)condicio1=true; //<--
					}
					if(q1.position.x<w1.position.x){
						if(pi.position.x>q1.position.x&&pi.position.x<w1.position.x)condicio1=true; //<--
					}
					if(q1.position.y>w1.position.y){
						if(pi.position.y>w1.position.y&&pi.position.y<q1.position.y)condicio2=true; //<--
					}
					if(q1.position.y<w1.position.y){
						if(pi.position.y>q1.position.y&&pi.position.y<w1.position.y)condicio2=true; //<--
					}
					// controlo els limits de la RECTA2
					if(q2.position.x>w2.position.x){
						if(pi.position.x>w2.position.x&&pi.position.x<q2.position.x)condicio3=true; //<--
					}
					if(q2.position.x<w2.position.x){
						if(pi.position.x>q2.position.x&&pi.position.x<w2.position.x)condicio3=true; //<--
					}
					if(q2.position.y>w2.position.y){
						if(pi.position.y>w2.position.y&&pi.position.y<q2.position.y)condicio4=true; //<--
					}
					if(q2.position.y<w2.position.y){
						if(pi.position.y>q2.position.y&&pi.position.y<w2.position.y)condicio4=true; //<--
					}
					if(condicio1==true&&condicio2==true&&condicio3==true&&condicio4==true){
						interseccio_valida = true;
						//----------------------------------------------------
						// rellenen la llaada en un color diferent
						//----------------------------------------------------
						ctx.beginPath();
						ctx.fillStyle="rgba(255,0,0,0.2)";
						//ctx.strokeStyle="rgb(255,0,0)";
						ctx.moveTo(pi.position.x,pi.position.y);								
						ctx.lineTo(q2.position.x,q2.position.y);
						
						for(n=i+2;n<=taula.length-3;n++){
							pp = taula[n];
							ctx.lineTo(pp.position.x,pp.position.y);
						}
											
						ctx.lineTo(w1.position.x,w1.position.y);
						ctx.lineTo(pi.position.x,pi.position.y);
						//ctx.stroke();
						ctx.fill();
						ctx.closePath();
						// -------------------------------------------------------
						
					}			
			//	}	
			}				
	}				
		
	// tinc que agafar imageDATA al principi de tot el pintat per examinar els pixels
	// la clau esta en posar la funcio getImageData a l'inici de tot el pintat dels enemics
	// despues puc controlar la posicio central de cada enemic i mirar si es negra o del color roig
	// que poso quan es fa una llaada
	
	imageData = ctx.getImageData(0,0,canvas.width, canvas.height);
	
	
	for(i=0;i<num_quadrats;i++){
		x = taula_quadrats[i].x + 5;
		y = taula_quadrats[i].y + 5;
		valorRoig = imageData.data[( y * imageData.width + x ) * 4 + 0];	
		valorVerd = imageData.data[( y * imageData.width + x ) * 4 + 1];
		valorBlau = imageData.data[( y * imageData.width + x ) * 4 + 2];
		// enemic mort 
		//*********************
		aux1 = x;
		aux2 = y;
		//*********************
		if(valorRoig==255&&valorVerd==0&&valorBlau==0){
			x = random(canvas.width/10-1)*10;
			y = random(canvas.height/10-1)*10;
			taula_quadrats[i].x = x;
			taula_quadrats[i].y = y;
			taula_quadrats[i].direccio = direccio;
			taula_quadrats[i].x_ini = x;
			taula_quadrats[i].y_ini = y;		
			taula_quadrats[i].canvi = false;		
			
					if(taula_quadrats[i].tipo == "zero"){
						if(op1==-1)op1 = 0;
						else op2=0;
					}
					if(taula_quadrats[i].tipo == "u"){
						if(op1==-1)op1 = 1;
						else op2=1;
					}
					if(taula_quadrats[i].tipo == "dos"){
						if(op1==-1)op1 = 2;
						else op2=2;
					}
					if(taula_quadrats[i].tipo == "tres"){
						if(op1==-1)op1 = 3;
						else op2=3;
					}
					if(taula_quadrats[i].tipo == "quatre"){
						if(op1==-1)op1 = 4;
						else op2=4;
					}
					if(taula_quadrats[i].tipo == "cinc"){
						if(op1==-1)op1 = 5;
						else op2=5;
					}
					if(taula_quadrats[i].tipo == "sis"){
						if(op1==-1)op1 = 6;
						else op2=6;
					}
					if(taula_quadrats[i].tipo == "set"){
						if(op1==-1)op1 = 7;
						else op2=7;
					}
					if(taula_quadrats[i].tipo == "vuit"){
						if(op1==-1)op1 = 8;
						else op2=8;
					}
					if(taula_quadrats[i].tipo == "nou"){
						if(op1==-1)op1 = 9;
						else op2=9;
					}
					// suma
					if(taula_quadrats[i].tipo == "suma"){
						operacio = "suma";
					}
					// resta
					if(taula_quadrats[i].tipo == "resta"){
						operacio = "resta";
					}
					// producte
					if(taula_quadrats[i].tipo == "producte"){
						operacio = "producte";
					}
					// divisio
					if(taula_quadrats[i].tipo == "divisio"){
						operacio = "divisio";
					}				
		}
		// pinto cada element
		ctx.fillStyle=taula_quadrats[i].color;
		
		if(taula_quadrats[i].color=="red"){	
			if(taula_quadrats[i].tipo=="zero"){			
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_zero,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_zero,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_zero,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_zero,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_zero,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_zero,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_zero,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_zero,taula_quadrats[i].x,taula_quadrats[i].y);				
			}
			if(taula_quadrats[i].tipo=="quatre"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_quatre,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_quatre,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_quatre,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_quatre,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_quatre,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_quatre,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_quatre,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_quatre,taula_quadrats[i].x,taula_quadrats[i].y);
			}
			if(taula_quadrats[i].tipo=="vuit"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_vuit,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_vuit,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_vuit,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_vuit,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_vuit,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_vuit,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_vuit,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_vuit,taula_quadrats[i].x,taula_quadrats[i].y);
			}
			if(taula_quadrats[i].tipo=="producte"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(producte,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(producte,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(producte,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(producte,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(producte,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(producte,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(producte,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(producte,taula_quadrats[i].x,taula_quadrats[i].y);
			}
		}
		
		if(taula_quadrats[i].color=="yellow"){	
			if(taula_quadrats[i].tipo=="u"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_u,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_u,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_u,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_u,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_u,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_u,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_u,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_u,taula_quadrats[i].x,taula_quadrats[i].y);	
			}
			if(taula_quadrats[i].tipo=="cinc"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_cinc,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_cinc,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_cinc,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_cinc,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_cinc,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_cinc,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_cinc,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_cinc,taula_quadrats[i].x,taula_quadrats[i].y);	
			}
			if(taula_quadrats[i].tipo=="nou"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_nou,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_nou,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_nou,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_nou,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_nou,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_nou,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_nou,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_nou,taula_quadrats[i].x,taula_quadrats[i].y);				
			}
		}	
		
		if(taula_quadrats[i].color=="green"){	
			if(taula_quadrats[i].tipo=="dos"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_dos,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_dos,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_dos,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_dos,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_dos,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_dos,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_dos,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_dos,taula_quadrats[i].x,taula_quadrats[i].y);	
			}
			if(taula_quadrats[i].tipo=="sis"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_sis,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_sis,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_sis,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_sis,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_sis,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_sis,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_sis,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_sis,taula_quadrats[i].x,taula_quadrats[i].y);
			}
			if(taula_quadrats[i].tipo=="suma"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(suma,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(suma,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(suma,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(suma,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(suma,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(suma,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(suma,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(suma,taula_quadrats[i].x,taula_quadrats[i].y);	
			}
		}
		
		if(taula_quadrats[i].color=="blue")	{	
			if(taula_quadrats[i].tipo=="tres"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_tres,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_tres,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_tres,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_tres,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_tres,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_tres,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_tres,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_tres,taula_quadrats[i].x,taula_quadrats[i].y);			
			}
			if(taula_quadrats[i].tipo=="set"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(numero_set,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(numero_set,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(numero_set,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(numero_set,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(numero_set,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(numero_set,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(numero_set,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(numero_set,taula_quadrats[i].x,taula_quadrats[i].y);		
			}
			if(taula_quadrats[i].tipo=="resta"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(resta,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(resta,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(resta,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(resta,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(resta,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(resta,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(resta,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(resta,taula_quadrats[i].x,taula_quadrats[i].y);		
			}
			if(taula_quadrats[i].tipo=="divisio"){	
				if(taula_quadrats[i].direccio==0)ctx.drawImage(divisio,taula_quadrats[i].x+1,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==1)ctx.drawImage(divisio,taula_quadrats[i].x-16,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==2)ctx.drawImage(divisio,taula_quadrats[i].x-6,taula_quadrats[i].y-16);	
				if(taula_quadrats[i].direccio==3)ctx.drawImage(divisio,taula_quadrats[i].x-6,taula_quadrats[i].y);	
				if(taula_quadrats[i].direccio==4)ctx.drawImage(divisio,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==5)ctx.drawImage(divisio,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==6)ctx.drawImage(divisio,taula_quadrats[i].x-6,taula_quadrats[i].y-6);	
				if(taula_quadrats[i].direccio==7)ctx.drawImage(divisio,taula_quadrats[i].x,taula_quadrats[i].y);	
			}			
		}
		
		// pinto l'estela de cada element
		ctx.beginPath();
		if(taula_quadrats[i].color=="red")		ctx.strokeStyle="rgba(255,0,0,0.2)";
		if(taula_quadrats[i].color=="yellow")	ctx.strokeStyle="rgba(255,255,0,0.2)";
		if(taula_quadrats[i].color=="green")	ctx.strokeStyle="rgba(0,255,0,0.2)";
		if(taula_quadrats[i].color=="blue")		ctx.strokeStyle="rgba(0,0,255,0.2)";
		
		ctx.lineWidth=10;
		ctx.moveTo(taula_quadrats[i].x_ini+5,taula_quadrats[i].y_ini+5);								
		ctx.lineTo(taula_quadrats[i].x+5,taula_quadrats[i].y+5);
		ctx.stroke();
		ctx.closePath();
	
	}
	// CONTADOR TEMPS PARTIDA
	ctx.beginPath();
	ctx.fillStyle="rgba(0,0,100,0.2)";
	ctx.strokeStyle="rgba(0,0,100,0.2)";
	ctx.lineWidth=30;
	ctx.moveTo(800, 625);								
	ctx.lineTo(1200, 625);
	ctx.stroke();
	ctx.fill();
	ctx.closePath();
	
	ctx.fillStyle="rgba(100,100,255,0.8)";
	ctx.font='14px Coriew New';
	ctx.fillText('TEMPS  '+contador_minuts+' m : '+contador_segons+' s', 800, 625);		
	
	// ESTEL
	ctx.fillStyle="rgba(255,255,255,0.2)";
	
	for (i=0;i<num_estrelles;i++) {
		ctx.fillRect(taula_estrelles[i].x,taula_estrelles[i].y,taula_estrelles[i].width,taula_estrelles[i].height);		// AQUI PINTO UNA ESTRELLA
	}
	
	ctx.drawImage(vDOWN,velocityDOWN.x,velocityDOWN.y);
	
	ctx.fillStyle="violet";	
	
	ctx.fillText('Velocitat actual: '+velocity, 650, 625);
	
	if(op1!=-1 && op2!=-1 ){

		if(operacio == "suma"){
			resultat = op1 + op2;				
		}
		if(operacio == "resta"){
			resultat = op1 - op2;			
		}
		if(operacio == "producte"){
			resultat = op1 * op2;			
		}
		if(operacio == "divisio"){
			resultat = op1 / op2;				
		}
	
		mostrat = true;
	
		taula_operacions_lliures.push(new op_lliure(op1,op2,operacio,resultat));
		num_op_lliures = num_op_lliures + 1;
		punts_partida = punts_partida + 1;		
		
		aux_op_lliures = num_op_lliures;
		if(num_op_lliures == 1){			
			num_op_lliures = 0;
		}		
	}
	
	if (mostrat == true){
		op1 = -1;
		op2 = -1;
		operacio = "op";
		mostrat = false;
	}
	
	taula_operacions_lliures.length>1&&taula_operacions_lliures.shift(); 
	
	var aux;
	for (i=0;i<aux_op_lliures;i++) {
	
		if(taula_operacions_lliures[i].operacio == "suma"){
			aux = "+";	
		}
		if(taula_operacions_lliures[i].operacio == "resta"){
			aux = "-";
		}
		if(taula_operacions_lliures[i].operacio == "producte"){
			aux = "*";
		}
		if(taula_operacions_lliures[i].operacio == "divisio"){
			aux = "/";
		}
		ctx.font='30px Coriew New';
		ctx.fillText("OPERACIO: "+taula_operacions_lliures[i].op1+" "+aux+" "+taula_operacions_lliures[i].op2+" = "+taula_operacions_lliures[i].resultat,25,550);	
		ctx.fillText("PUNTUACIO:  "+punts_partida,25,600);	
		
	}
}

function random(max){
	return parseInt(Math.random()*max);
}

// classe que contindra les dades necessaries d'una operacio lliure
function op_lliure (op1, op2, operacio, resultat){
	this.op1 = op1;
	this.op2 = op2;
	this.operacio = operacio;
	this.resultat = resultat;	
}

function incrementar_temps(){
	contador_segons = contador_segons + 1;
	if(contador_segons > 59) {
		contador_minuts = contador_minuts + 1;
		contador_segons = 0;
	}
	if(contador_minuts==0){
		nivell=0;
		if(estat_velocity == 0){
			velocity = 2;
		}
		if(estat_velocity == 1){
			velocity = 1;
		}
	}
	if(contador_minuts==1){
		nivell=1;
		if(estat_velocity == 0){
			velocity = 4;
		}
		if(estat_velocity == 1){
			velocity = 2;
		}
	}
	if(contador_minuts==2){
		nivell=2;
		if(estat_velocity == 0){
			velocity = 5;
		}
		if(estat_velocity == 1){
			velocity = 2.5;
		}
	}
	if(contador_minuts==3){
		nivell=3;
		if(estat_velocity == 0){
			velocity = 6;
		}
		if(estat_velocity == 1){
			velocity = 3;
		}
	}
	if(contador_minuts==4){
		nivell=4;
		if(estat_velocity == 0){
			velocity = 7;
		}
		if(estat_velocity == 1){
			velocity = 3.5;
		}
	}
	if(contador_minuts==5){
		nivell=5;
		if(estat_velocity == 0){
			velocity = 8;
		}
		if(estat_velocity == 1){
			velocity = 4;
		}
	}
	if(contador_minuts==6){
		nivell=6;
		if(estat_velocity == 0){
			velocity = 9;
		}
		if(estat_velocity == 1){
			velocity = 4.5;
		}
	}
	if(contador_minuts==7){
		nivell=7;
		if(estat_velocity == 0){
			velocity = 10;
		}
		if(estat_velocity == 1){
			velocity = 5;
		}
	}
	if(contador_minuts==8){
		nivell=8;
		if(estat_velocity == 0){
			velocity = 10;
		}
		if(estat_velocity == 1){
			velocity = 5;
		}
	}
	if(contador_minuts==9){
		nivell=9;
		if(estat_velocity == 0){
			velocity = 10;
		}
		if(estat_velocity == 1){
			velocity = 5;
		}
	}
	if(contador_minuts==10){
		nivell=10;
		if(estat_velocity == 0){
			velocity = 12;
		}
		if(estat_velocity == 1){
			velocity = 6;
		}
	}
	
}

function nova_velocitat(){
	estat_velocity = 0;
}

function canvi_direccio(){
	
		direccio = random(8);
		if(direccio==0)angle_direccio=Math.PI/2;
		if(direccio==1)angle_direccio=-Math.PI/2;
		if(direccio==2)angle_direccio=0;
		if(direccio==3)angle_direccio=Math.PI;
		if(direccio==4)angle_direccio=Math.PI/4;
		if(direccio==5)angle_direccio=Math.PI/4+Math.PI;
		if(direccio==6)angle_direccio=Math.PI/2+Math.PI+Math.PI/4;
		if(direccio==7)angle_direccio=Math.PI/4+Math.PI/2;		
		
		setTimeout(canvi_direccio,1000*30);
	
}

function Point(j,t){this.position={x:j,y:t}}

// classe Super M

function superM (x, y ,width, height){

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.colision = function (obj) {
		if(obj!=null){
			return(this.x < obj.x + obj.width && this.x + this.width > obj.x && this.y < obj.y + obj.height && this.y + this.height > obj.y);
		}
	}
	
}

// classe Quadrat

function quadrat (x, y ,direccio, x_ini, y_ini, width, height, canvi, color, tipo){

	this.x = x;
	this.y = y;
	this.direccio = direccio;
	this.x_ini = x_ini;
	this.y_ini = y_ini;
	this.width = width;
	this.height = height;
	this.canvi = canvi;
	this.color = color;
	this.tipo = tipo;
	this.colision = function (obj) {
		if(obj!=null){
			return(this.x < obj.x + obj.width && this.x + this.width > obj.x && this.y < obj.y + obj.height && this.y + this.height > obj.y);
		}
	}
	
}

// classe Estrella

function estrella (x, y ,width, height, color, direccio, canvi){

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.color = color;
	this.direccio = direccio;
	this.canvi = canvi;
	
}

// classe Enemic

function enemic (x, y ,width, height, estat){

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.estat = estat;
	this.colision = function (obj) {
		if(obj!=null){
			return(this.x < obj.x + obj.width && this.x + this.width > obj.x && this.y < obj.y + obj.height && this.y + this.height > obj.y);
		}
	}
	
}

// classe enemic auxiliar
function enemic_auxiliar (x, y ,width, height){

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	
}

function calcul_angle(wx,wy,qx,qy){
	if(qx>wx){
		v1x = qx-wx;
		v1y = qy-wy;
		v2x = canvas.width-wx;
		v2y = wy-wy;
		producte_escalar = Math.abs(v2x*v1x + v2y*v1y);
		modul_v1 = Math.sqrt(v1x*v1x + v1y*v1y);
		modul_v2 = Math.sqrt(v2x*v2x + v2y*v2y);
		denominador = modul_v1 * modul_v2;
		resultat = producte_escalar / denominador;
		angle = Math.acos(resultat);
	}
	if(qx<wx){
		v1x = wx-qx;
		v1y = wy-qy;
		v2x = canvas.width-qx;
		v2y = qy-qy;
		producte_escalar = Math.abs(v2x*v1x + v2y*v1y);
		modul_v1 = Math.sqrt(v1x*v1x + v1y*v1y);
		modul_v2 = Math.sqrt(v2x*v2x + v2y*v2y);
		denominador = modul_v1 * modul_v2;
		resultat = producte_escalar / denominador;
		angle = Math.acos(resultat);
	}
	angle = angle*180/Math.PI;
	//if(angle<0)angle = angle + 360;
	return (angle);
}

function controlar_interseccio (wx1,wy1,qx1,qy1,wx2,wy2,qx2,qy2){//,xmin,ymin,xmax,ymax){
	// RECTA W1-Q1
	// coordenades punt W1
	x1 = wx1;
	y1 = wy1;
	// coordenades punt Q1
	x2 = qx1;
	y2 = qy1;	
	v1 = x2 - x1;
	v2 = y2 - y1;	
	//------------------------
	a1 = v2;	
	b1 = -v1;	
	c1 = -v1*y1 + v2*x1;
	//------------------------
	// RECTA W2-Q2
	// coordenades punt W2
	x3 = wx2;
	y3 = wy2;
	// coordenades punt Q2
	x4 = qx2;
	y4 = qy2;
	v3 = x4 - x3;
	v4 = y4 - y3;	
	//------------------------
	a2 = v4;	
	b2 = -v3;	
	c2 = -v3*y3 + v4*x3;
	//------------------------
	
	//sortida = false;
	denominador = a1*b2-b1*a2;
	// si el sistema no te soluci
	if (denominador == 0){
		//sortida = false;
		sortida = new Point(-1,-1);

	}
	// si el sistema t soluci
	else{
		x = (c1*b2-b1*c2)/denominador;
		y = (a1*c2-c1*a2)/denominador;
		sortida = new Point(x,y);
	}
	
	return sortida;	
		
}

function informacion_pulsacion_raton(evt){

	coordenadaX = evt.clientX-canvas.offsetLeft;//evt.clientX-40;
	coordenadaY = evt.clientY-canvas.offsetTop;//evt.clientY-20;
		
}

document.onmousemove = informacion_pulsacion_raton;

